require 'erb'

module Faster

  class ErbProcessor
    def initialize(filename, source, context_class = ErbContext)
      @context_class = context_class
      @erb = ERB.new(source, nil, nil, '@erb')
      @erb.filename = filename
    end

    def render
      context.render(@erb)
    end

    private
    def context
      @context_class.new
    end
  end

  class ErbContext
    def self.add(mod)
      self.send :include, mod
    end

    def concat(str)
      @erb << str.gsub(/^\s+/, "")
    end

    def render(erb)
      erb.result(binding)
    end
  end

end

